<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1, shrink-to-fit=no"
    />
    <title>Bootstrap Flex</title>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css"
      integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn"
      crossorigin="anonymous"
    />
  </head>
  <body>
    <h1 class="text-center my-5">Bootstrap Flex</h1>

    <!-- 
      Flexbox is used to manipulate and layout our elements. This can be done exclusively in CSS. However, using bootstrap it is much easier and faster to implement flex because all we have to do is add the class="d-flex" (display: flex) to the parent element (parent elements are NOT flex items, just the children are flex items)

      Flex items, Flex children, when adding d-flex to their parent, the items are in a row. We can adjust their height and width not like your inline elements.not the same as inline block

      Flex items - can take a height and a width but only if their parent element has a height and width 

      Flex-directions: 
      - by default flex items are arranged in a row (default: flex-row)
        - left to right
      - can change the direction of the flex items with flex-direction

      - Flex Row Reverse
        - starts items from the opposite side (right) and reverses the order of the flex items 
        - right to left 

      - Flex Column
        - arranges items from top to bottom and by default the flex items will occupy the width of its parent 

      -flex col reverse
        - does the same as flex col but it starts from the bottom to the top 
     -->
    <h3 class="text-center my-3">Flex row</h3>
    <div class="bg-dark d-flex flex-row mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row mb-4">
      <span class="bg-primary p-2">Span Flex 1</span>
      <span class="bg-danger p-2">Span Flex 2</span>
      <span class="bg-success p-2">Span Flex 3</span>
    </div>
    <h3 class="text-center my-5">Flex Row Reverse</h3>
    <div class="d-flex flex-row-reverse bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5">Flex Column</h3>
    <div class="d-flex flex-column bg-dark mb-4 p-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-column p-4 mb-4">
      <span class="bg-primary p-2">Span Flex 1</span>
      <span class="bg-danger p-2">Span Flex 2</span>
      <span class="bg-success p-2">Span Flex 3</span>
    </div>
    <h3 class="my-5 text-center">Flex Column Reverse</h3>
    <div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <!-- justify content -->
    <h2 class="text-center my-5">Justify Content</h2>
    <!-- justify-content : manipulates and changes alignment of flex items along our main axis 
        - the main axis for flex row items is our x-axis 
        - allows us to horizontally align our flex-row items 
    -->
    <h3 class="text-center my-5">Justify Content Start</h3>
    <!-- justify-content-start is the default value of justify-content for flex items; aligns flex items to the start of the main axis (x-axis); for flex-row it starts at the left; for reverse, starts from the right -->
    <div class="bg-dark d-flex flex-row justify-content-start mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-start mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5">Justify Content End</h3>
    <!-- aligns our flex items where our main axis ends. For flex row the end is from the right and for reverse, end is from the left -->
    <div class="bg-dark d-flex flex-row justify-content-end mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-end mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <h3 class="text-center my-5">Justify Content Center</h3>
    <!-- aligns flex items at the center of the main axis. the main axis for both flex row and reverse is the x-axis; can center items horizontally  -->
    <div class="bg-dark d-flex flex-row justify-content-center mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="bg-dark d-flex flex-row-reverse justify-content-center mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5">Justify Content Between</h3>
    <!-- evenly distributes the remaining spaces in between our items -->
    <div class="d-flex flex-row justify-content-between bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
      <div class="bg-warning p-2">Flex Item 4</div>
      <div class="bg-info p-2">Flex Item 5</div>
    </div>
    <div class="d-flex flex-row-reverse justify-content-between bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
      <div class="bg-warning p-2">Flex Item 4</div>
      <div class="bg-info p-2">Flex Item 5</div>
    </div>
    <h3 class="text-center my-5">Justify Content Around</h3>
    <!-- evenly distributes space around your items -->
    <div class="d-flex flex-row justify-content-around bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div class="d-flex flex-row-reverse justify-content-around bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <!-- ALIGN ITEMS -->
    <h2 class="text-center my-3">Align Items</h2>
    <!-- align items - aligns items vertically for flex row and reverse -->
    <h3 class="text-center my-5">Align Items Start</h3>
    <!-- aligns flex items at the top or start of the y axis
        - flex row and reverse, the y axis is the cross axis and the x-axis is the main axis 
          - start of y-axis is at the top 
        - flex column and reverse, the y axis is the main axis and the x-axis is the main axis.
    -->
    <div
      class="d-flex flex-row align-items-start bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div
      class="d-flex flex-row-reverse align-items-start bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <h3 class="text-center my-5">Align Items End</h3>
    <div
      class="d-flex flex-row align-items-end bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div
      class="d-flex flex-row-reverse align-items-end bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <h3 class="text-center my-5">Align Items Center</h3>
    <div
      class="d-flex flex-row align-items-center bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div
      class="d-flex flex-row-reverse align-items-center bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <h2 class="text-center my-5">Aligning Items Horizontally and Vertically</h2>
    <div
      class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div
      class="
        d-flex
        flex-row
        align-items-end
        justify-content-around
        bg-dark
        mb-4
      "
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <div
      class="
        d-flex
        flex-row
        align-items-center
        justify-content-end
        bg-dark
        mb-4
      "
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <!-- MINI ACTIVITY -->
    <h3 class="text-center my-5">Mini Activity with Flex Row</h3>

    <div
      class="
        d-flex
        flex-row
        justify-content-center
        align-items-center
        bg-dark
        mb-4
      "
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <div
      class="
        d-flex
        flex-row
        justify-content-between
        align-items-center
        bg-dark
        mb-4
      "
      style="height: 50vh"
    >
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Ite m 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>

    <h2 class="text-center my-5">
      Flex Column with Align Items and Justify Content
    </h2>
    <!-- 
    flex row and reverse, align items aligns flex row vertically; justify-content aligns flex row horizontally 

    flex columm and reverse, align items aligns flex cols horizontally; justify-content aligns flex cols vertically 

 -->
    <div
      class="d-flex flex-column align-items-center bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 30%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 30%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 30%">Flex Item 3</div>
    </div>
    <div
      class="d-flex flex-column justify-content-center bg-dark mb-4"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 30%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 30%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 30%">Flex Item 3</div>
    </div>

    <!-- MINI ACTIVITY -->
    <h3 class="text-center my-5">Mini Activity with Flex Column</h3>
    <div
      class="bg-dark mb-4 d-flex flex-column justify-content-end"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 20%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 20%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 20%">Flex Item 3</div>
    </div>
    <div
      class="bg-dark mb-4 d-flex flex-column align-items-end"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 20%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 20%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 20%">Flex Item 3</div>
    </div>

    <h3 class="text-center my-5">
      Flex Column with Justify Content Between and Around
    </h3>
    <div
      class="bg-dark mb-4 d-flex flex-column justify-content-between"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 20%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 20%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 20%">Flex Item 3</div>
    </div>
    <div
      class="bg-dark mb-4 d-flex flex-column justify-content-around"
      style="height: 50vh"
    >
      <div class="bg-primary p-2" style="width: 20%">Flex Item 1</div>
      <div class="bg-danger p-2" style="width: 20%">Flex Item 2</div>
      <div class="bg-success p-2" style="width: 20%">Flex Item 3</div>
    </div>

    <h3 class="text-center my-5">Flex Wrap</h3>
    <div class="d-flex flex-row flex-wrap justify-content-around bg-dark mb-4">
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
      <div class="bg-primary p-2">Flex Item 1</div>
      <div class="bg-danger p-2">Flex Item 2</div>
      <div class="bg-success p-2">Flex Item 3</div>
    </div>
    <!-- *** JS DEPENDENCIES *** -->
    <script
      src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
      integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js"
      integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF"
      crossorigin="anonymous"
    ></script>
  </body>
</html>
